main :: IO()
main = print (r)

{-
    Make a move on the board
    Input: board, tar_cor, side
    Return: board
-}
makeAMove board tar_cor side = makeAMoveHelper board tar_cor 0 side

makeAMoveHelper (x:xs) (tar_x, tar_y) curr_x side
    | tar_x == curr_x = (makeAMoveRow x tar_y side) : xs
    | otherwise = x:(makeAMoveHelper xs (tar_x, tar_y) (curr_x+1) side)

makeAMoveRow row index side = makeAMoveRowHelper row index 0 side

makeAMoveRowHelper (x:xs) tar_index curr_index side
    | tar_index == curr_index = side : xs 
    | otherwise = x:(makeAMoveRowHelper xs tar_index (curr_index+1) side)




{-
    Score a board for one board
    Input: board 
    Return: score (int)
-}
scoreBoard board = (scoreBoardOneSide board 1) - (scoreBoardOneSide board (-1))

scoreBoardOneSide board side = (scoreBoardOneDirection board side) + (scoreBoardOneDirection (flipBoard board) side)

scoreOneRow row side = scoreOneRowHelper row side 0

scoreHelper num = case num of 
    2 -> 100
    3 -> 1000
    4 -> 10000
    5 -> 100000
    _ -> 0

scoreOneRowHelper row side num 
    | null row = scoreHelper num
    | otherwise = let (x:xs) = row in 
        do
            if x == side
                then scoreOneRowHelper xs side (num + 1)
            else (scoreHelper num) + (scoreOneRowHelper xs side 0)

scoreBoardOneDirection board side = sum [scoreOneRow row side | row <- board]

flipBoard matrix 
    | null matrix = [[] | _ <- [1 .. 9]]
    | otherwise = let (x:xs) = matrix in
        [a:b | (a,b) <- (zip x (flipBoard xs))]


{-
    Get all possible moves on the board
    Input: board
    Return: moves [(int,int)]
-}
getAllMoves board = getAllMovesHelper board 0

getAllMovesHelper board row_index
    | null board = []
    | otherwise = let (x:xs) = board in
        (getAllMovesOneRow x row_index) ++ (getAllMovesHelper xs (row_index + 1))

getAllMovesOneRow row row_index = getAllMovesOneRowHelper row row_index 0

getAllMovesOneRowHelper row row_index curr_index
    | null row = []
    | otherwise = let (x:xs) = row in 
        do
            if x == 0
                then (row_index, curr_index):(getAllMovesOneRowHelper xs row_index (curr_index + 1))
            else getAllMovesOneRowHelper xs row_index (curr_index + 1)


{-
    AI functions
-}

initializeBestScore side 
    | side == 1 = -100000
    | otherwise = 100000
initializeAlphaBeta side = -1 * (initializeBestScore side)

switchSide side
    | side == 1 = -1
    | otherwise = 1

chooseBetterScore side (score1, move1) (score2, move2) = 
    do 
        if (side == 1 && score1 > score2) || (side == -1 && score1 < score2)
            then (score1, move1)
        else
            (score2, move2)

goThroughMovesHelper moves bestScore bestMove side board depth curr_depth alpha_beta
    | length moves == 0 = (bestScore, bestMove)
    | otherwise = let (x:xs) = moves in
                    let movedBoard = makeAMove board x side in
                        let (newBestScore, newBestMove) = getBestMoveHelper movedBoard (switchSide side) depth (curr_depth + 1) bestScore in
                            do 
                                if (side == 1 && newBestScore > alpha_beta) || (side == -1 && newBestScore < alpha_beta) 
                                    then (newBestScore, x)
                                else
                                    let (bestScore_, bestMove_) = chooseBetterScore side (bestScore, bestMove) (newBestScore, x) in
                                        goThroughMovesHelper xs bestScore_ bestMove_ side board depth curr_depth alpha_beta

getBestMoveHelper board side depth curr_depth alpha_beta
    | curr_depth == depth = ((scoreBoard board), (-1,-1))
    | otherwise = 
        let bestScore = initializeBestScore side in
            let bestMove = (-1,-1) in
                let possibleMoves = getAllMoves board in 
                    goThroughMovesHelper possibleMoves bestScore bestMove side board depth curr_depth alpha_beta


getBestMove board side depth = 
    let alpha_beta = initializeAlphaBeta side in
        let (_, bestMove) = getBestMoveHelper board side depth 0 alpha_beta in 
            bestMove


-- ================ testing -- ================
boardEmpty = [
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0]
    ]

board1 = [
        [0,1,1,0,0,0,0,0,0],
        [0,1,0,0,0,0,0,0,0],
        [0,0,0,1,1,1,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,-1,-1,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0]
    ]

board2 = [
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,0,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,0,0],
        [0,0,0,0,0,0,0,0,0]
    ]

board3 = [
        [0,0,0,0,0,0,0,0,0],
        [0,0,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,1,1,1,1,1,1],
        [1,1,1,0,0,0,0,0,0],
        [0,0,0,0,0,0,0,0,0]
    ]

r = getBestMove board1 1 4
b = getBestMove board1 (-1) 3